
;Pcspace-Grafiktreiber ET3000- 16Farben
;
;Zum Erstellen von ET3000l.drv:
; tasm et3000l
; tlink et3000l
; exe2bin et3000l
; ren et3000l.bin et3000l.drv
;
; Achtung: Maximallnge der drv datei: 128 Bytes

prog  segment para 'code'
 assume cs:prog
 assume ds:prog
 assume ss:prog
 assume es:prog

start  proc  far
       ; Einsprung Videomodus initialisieren
       jmp short init

       ; Einsprung 64k Bank setzen und Segmentadresse nach ex
       ; in al ist die bank nr.
       jmp short bank
     ;Treiberparameter

       db 15 ;Anzahl der Farben-1
       ;Parametertabelle fr Initialisierung
       db 12h ;Modus 0: Auflsung 640*480
       db 29h ;Modus 1: Auflsung 800*600
       db 37h ;Modus 2: Auflsung 1024*768

       db "ET3000 16Farben" ;Identifizierungstext fr Setup
       db 0                 ;Lnge kann variabel sein

     ;Videomodus initialisieren
     ;Verwedete Register: ax,bx
 init: ;al wurde mit dem Wert der Parametertabelle besetzt
       ;Auflsung nicht vorhanden (Par.-1) wurde schon abgefangen.

       xor  ah,ah
       int  10h
       db 0cbh ;retf

     ;Videobank setzen
     ;Verwedete Register: ax,dx,es
 bank: mov  ah,0a0h
       or   ah,al
       xor  al,al

       ;segmentadr. Videospeicher
       mov  es,ax
       db 0cbh   ;retf

start  endp

prog  ends

 end  start