
;Pcspace-Grafiktreiber ET4000- 16Farben
;
;Zum Erstellen von ET4000l.drv:
; tasm et4000l
; tlink et4000l
; exe2bin et4000l
; ren et4000l.bin et4000l.drv
;
; Achtung: Maximallnge der drv datei: 128 Bytes

prog  segment para 'code'
 assume cs:prog
 assume ds:prog
 assume ss:prog
 assume es:prog

start  proc  far
       ; Einsprung Videomodus initialisieren
       jmp short init

       ; Einsprung 64k Bank setzen und Segmentadresse nach ex
       ; in al ist die bank nr.
       jmp short bank
     ;Treiberparameter

       db 15 ;Anzahl der Farben-1
       ;Parametertabelle fr Initialisierung
       db 12h ;Modus 0: Auflsung 640*480
       db 29h ;Modus 1: Auflsung 800*600
       db 37h ;Modus 2: Auflsung 1024*768

       db "ET4000 16Farben" ;Identifizierungstext fr Setup
       db 0                 ;Lnge kann variabel sein

     ;Videomodus initialisieren
     ;Verwedete Register: ax,bx
 init: ;al wurde schon dem Wert der Parametertabelle besetzt
       ;Auflsung nicht vorhanden (Par.-1) wurde schon abgefangen.

       xor  ah,ah
       int  10h
       db 0cbh ;retf

     ;Videobank setzen
     ;Verwedete Register: ax,dx,es
 bank: mov  ah,al
       shl  ah,1
       shl  ah,1
       shl  ah,1
       shl  ah,1
       or   al,ah

       mov  dx,03cdh
       out  dx,al
       ;segmentadr. Videospeicher
       mov  dx,0a000h
       mov  es,dx
       db 0cbh   ;retf

start  endp

prog  ends

 end  start