
;Pcspace-Grafiktreiber PARADISE- 256Farben
;
;Zum Erstellen von PARADISh.drv:
; tasm paradish
; tlink paradish
; exe2bin paradish
; ren paradish.bin paradish.drv
;
; Achtung: Maximallnge der drv datei: 128 Bytes

prog  segment para 'code'
 assume cs:prog
 assume ds:prog
 assume ss:prog
 assume es:prog

start  proc  far
       ; Einsprung Videomodus initialisieren
       jmp short init

       ; Einsprung 64k Bank setzen und Segmentadresse nach ex
       ; in al ist die bank nr.
       jmp short bank
     ;Treiberparameter

       db 255 ;Anzahl der Farben-1
       ;Parametertabelle fr Initialisierung
       db 5fh ;Modus 0: Auflsung 640*480
       db  0  ;Modus 1: Auflsung 800*600  (vielleicht nicht vorhanden)
       db  1  ;Modus 2: Auflsung 1024*768 (vielleicht nicht vorhanden)

       db "Paradise 256Farben" ;Identifizierungstext fr Setup
       db 0                    ;Lnge kann variabel sein

     ;Videomodus initialisieren
     ;Verwedete Register: ax,bx
 init: ;al wurde mit dem Wert der Parametertabelle besetzt
       ;Auflsung nicht vorhanden (Par.-1) wurde schon abgefangen.

       xor  ah,ah
       cmp  al,2
       jb   smode
       int  10h

 smode:push cx
       push dx
       mov  cx,600
       mov  bx,800
       or   al,al
       jz   mode1
       mov  cx,768
       mov  bx,1024

 mode1:mov  dx,0100h
       mov  al,7eh
       int  10h
       pop  dx
       pop  cx
       db 0cbh ;retf

     ;Videobank setzen
     ;Verwedete Register: ax,dx,es
 bank: mov  ah,al
       shl  ah,1
       shl  ah,1
       shl  ah,1
       shl  ah,1
       mov  al,9

       mov  dx,03ceh
       out  dx,ax

       ;segmentadr. Videospeicher
       mov  dx,0a000h
       mov  es,dx
       db 0cbh   ;retf

start  endp

prog  ends

 end  start
